#ifndef EFL_GFX_STACK_EO_HH
#define EFL_GFX_STACK_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_gfx_stack.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace gfx { 
struct Stack;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::gfx::Stack> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace gfx { 
struct Stack {
   ::efl::eolian::return_traits<short>::type layer_get() const;
   ::efl::eolian::return_traits<void>::type layer_set( ::efl::eolian::in_traits<short>::type l) const;
   ::efl::eolian::return_traits< ::efl::gfx::Stack>::type below_get() const;
   ::efl::eolian::return_traits< ::efl::gfx::Stack>::type above_get() const;
   ::efl::eolian::return_traits<void>::type stack_below( ::efl::eolian::in_traits< ::efl::gfx::Stack>::type below) const;
   ::efl::eolian::return_traits<void>::type raise() const;
   ::efl::eolian::return_traits<void>::type stack_above( ::efl::eolian::in_traits< ::efl::gfx::Stack>::type above) const;
   ::efl::eolian::return_traits<void>::type lower() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_GFX_STACK_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::gfx::Stack() const;
   operator ::efl::gfx::Stack&();
   operator ::efl::gfx::Stack const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Stack> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Stack const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace gfx { 
struct Stack : ::efl::eo::concrete
{
   explicit Stack( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Stack(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Stack(Stack const& other) = default;
   Stack(Stack&& other) = default;
   Stack& operator=(Stack const& other) = default;
   Stack& operator=(Stack&& other) = default;
   Stack()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Stack( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Stack(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<short>::type layer_get() const;
   ::efl::eolian::return_traits<void>::type layer_set( ::efl::eolian::in_traits<short>::type l) const;
   ::efl::eolian::return_traits< ::efl::gfx::Stack>::type below_get() const;
   ::efl::eolian::return_traits< ::efl::gfx::Stack>::type above_get() const;
   ::efl::eolian::return_traits<void>::type stack_below( ::efl::eolian::in_traits< ::efl::gfx::Stack>::type below) const;
   ::efl::eolian::return_traits<void>::type raise() const;
   ::efl::eolian::return_traits<void>::type stack_above( ::efl::eolian::in_traits< ::efl::gfx::Stack>::type above) const;
   ::efl::eolian::return_traits<void>::type lower() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_GFX_STACK_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct restack_event
   {
      static Eo_Event_Description const* description()
      { return EFL_GFX_EVENT_RESTACK; }
      typedef void parameter_type;
   } const restack_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Stack> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Stack const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Stack) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Stack>::value, "");
} } 
#include "efl_gfx_stack.eo.impl.hh"
#endif
